/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.ui;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Stroke;
import kinugasa.object.Model;
import kinugasa.object.Sprite;

/**
 * kinugasa : MessageWindowModel : メッセージウインドウの初期設定および下地とラベルの描画行うモデルです.
 * <br>
 * このモデルの内部でカウンタを使用する場合は十分注意してください.そのようなモデルを使用する場合は
 * 常に新しいインスタンスを使用してください.<Br>
 * 
 * @version 1.0.0 - 2012/07/16_18:07:10.<br>
 * @version 2.0.0 - 2012/11/26_::.<br>
 * @author Dra0211<br>
 * <br>
 */
public abstract class MessageWindowModel extends Model {

	private static final long serialVersionUID = -3101131626178958221L;

	/**
	 * 新しいモデルを構築します.
	 */
	public MessageWindowModel() {
		super();
	}

	/**
	 * メッセージウインドウおよびテキストを描画します.
	 * 
	 * @param g グラフィックスコンテキスト.<Br>
	 * @param w メッセージウインドウ.<Br>
	 */
	public abstract void drawWindow(Graphics2D g, MessageWindow w);

	/**
	 * メッセージウインドウwの持つすべてのラベルに適切な座標を設定します.
	 * このメソッドはウインドウに新しいテキストが設定された全てのタイミングでコールされます.<br>
	 * 
	 * @param w ウインドウ.0個以上のラベルを持つ.ラベルの状態は実装により異なる.<br>
	 */
	public abstract void initLabels(MessageWindow w);

	/**
	 * 通常のアルゴリズムを用いて全てのラベルをウインドウの座標に並べます.
	 *
	 * @param w       ウインドウの実装を送信します。<br<
	 * @param xBlank  X方向のウインドウの座標からラベルの配置位置までのギャップを指定します。<br>
	 * @param yBlank  Y方向のウインドウの座標からラベルの配置位置までのギャップを指定します。<br>
	 * @param lineGap 行間を指定します。<br>
	 */
	protected final void lineUpText(MessageWindow w, float xBlank, float yBlank, float lineGap) {
		TextLabel[] tl = w.getLabels();
		float x = w.getX() + xBlank;
		float y = w.getY() + yBlank;
		for (int i = 0; i < tl.length; i++) {
			tl[i].setLocation(x, y);
			y += tl[i].getLabelModel().getFontSize() + lineGap;
		}
	}

	/**
	 * 指定されたテキストラベルをすべて描画し、ラベルの表示文字インデックスを更新します.
	 *
	 * @param g  書き込むグラフィックスコンテキストを送信します。<br>
	 * @param tl 描画するラベルの配列を送信します。<br>
	 */
	protected final void drawText(Graphics2D g, TextLabel... tl) {
		int line = 0;
		for (int i = 0; i < tl.length; i++) {
			if (!tl[i].isAllTextVisible()) {
				line = i;
				break;
			}
			line++;
		}
		for (int i = 0; i < tl.length && i <= line; i++) {
			if (!tl[i].isAllTextVisible() && tl[i].getTimeCounter().isReaching()) {
				tl[i].nextChar();
			}
			tl[i].draw(g);
		}
	}

	/**
	 * テキストアイコンに適切な位置を設定します.
	 * このメソッドが、ウインドウに新しいアイコンが設定されたタイミングでコールされます.<br>
	 * このメソッドではウインドウのiconがnullである可能性があります.<br>
	 * 
	 * @param w ウインドウ.<br>
	 */
	public abstract void initIcon(MessageWindow w);

	@Override
	public MessageWindowModel clone() {
		return (MessageWindowModel) super.clone();
	}
	/**
	 * DQ5っぽいメッセージウインドウの実装です.
	 */
	public static final MessageWindowModel DQ5_STYLE_WINDOW_MODEL = new SimpleWindowModel(Color.BLACK, Color.WHITE, new Color(140, 140, 140), new Color(32, 32, 32));
	/**
	 * FF3っぽいメッセージウインドウの実装です.
	 */
	public static final MessageWindowModel FF3_STYLE_WINDOW_MODEL = new SimpleWindowModel(Color.BLACK, new Color(255, 255, 255), new Color(140, 140, 140), new Color(16, 32, 172));
}